unit ufrmcadexe;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  StdCtrls, Grids, Buttons;




type


  { TfrmCADEXE }

  TfrmCADEXE = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    CheckBox1: TCheckBox;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    pnpTitulo: TPanel;
    StringGrid1: TStringGrid;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
   procedure DeleteRow(StringGrid: TStringGrid;ARow:integer);
  public

  end;
TYPE
  TStringGridHack = class(TStringGrid)
    protected
      procedure DeleteRow(ARow: Longint); reintroduce;
      procedure InsertRow(ARow: Longint);
    end;
var
  frmCADEXE: TfrmCADEXE;

implementation

uses
  Unit1;

{$R *.lfm}

{ TfrmCADEXE }

procedure TStringGridHack.DeleteRow(ARow: Longint);
var
  GemRow: Integer;
begin
  GemRow := Row;
  if RowCount > FixedRows + 1 then
    inherited DeleteRow(ARow)
  else
    Rows[ARow].Clear;
  if GemRow < RowCount then
    Row := GemRow;
end;

procedure TStringGridHack.InsertRow(ARow: Longint);
var
  GemRow: Integer;
begin
  GemRow := Row;
  while ARow < FixedRows do
    Inc(ARow);
  RowCount := RowCount + 1;
  Row := GemRow;
end;

procedure TfrmCADEXE.DeleteRow(StringGrid: TStringGrid; ARow: integer);
var
  i, j: integer;
begin
  with StringGrid do
  begin
    for i := ARow to RowCount - 2 do
      for j := 0 to ColCount - 1 do
        Cells[j, i] := Cells[j, i + 1];
    RowCount := RowCount - 1;
  end;
end;

procedure TfrmCADEXE.FormCreate(Sender: TObject);
  var
  I: Integer;
begin
  { Aumenta as colunas }
  for i := 0 to StringGrid1.ColCount -1 do
    StringGrid1.ColWidths[i] := 150;
  { Insere alguns itens para teste e atualiza o RowCount }
  for i := 0 to 3 do
    TStringGridHack(StringGrid1).InsertRow(1);
  {Criar as colunas }
  StringGrid1.Cells[0,0] := 'Autor ';
  StringGrid1.Cells[1,0] := 'Nome da Obra ';
  StringGrid1.Cells[2,0] := 'QTD de Pag';
  StringGrid1.Cells[3,0] := 'Valor ';

  { Alimenta com os registros }
  StringGrid1.Cells[0,1] := 'Monteiro Lobato';
  StringGrid1.Cells[1,1] := 'Santos';
  StringGrid1.Cells[2,1] := '200';
  StringGrid1.Cells[3,1] := '100,00';

  StringGrid1.Cells[0,2] := 'José de Alencar';
  StringGrid1.Cells[1,2] := 'Iracema ';
  StringGrid1.Cells[2,2] := '120';
  StringGrid1.Cells[3,2] := '200,00';

  StringGrid1.Cells[0,3] := 'Paulo Coelho';
  StringGrid1.Cells[1,3] := 'O Alquimista ';
  StringGrid1.Cells[2,3] := '130,000';
  StringGrid1.Cells[3,3] := '250,00';

  StringGrid1.Cells[0,4] := 'Machado de Assis';
  StringGrid1.Cells[1,4] := 'Dom Casmurro ';
  StringGrid1.Cells[2,4] := '100';
  StringGrid1.Cells[3,4] := '130,00';
end;
procedure TfrmCADEXE.Button1Click(Sender: TObject);
var
  I : Integer;
  procedure Inserir(ALinha: Integer; ANome, ASobreNome, AEmail, ASite: String);
  begin
    StringGrid1.Cells[0, ALinha] := ANome;
    StringGrid1.Cells[1, ALinha] := ASobreNome;
    StringGrid1.Cells[2, ALinha] := AEmail;
    StringGrid1.Cells[3, ALinha] := ASite;
  end;
begin
  if ((Trim(Edit1.Text) = '') or
      (Trim(Edit2.Text) = '') or
      (Trim(Edit3.Text) = '') or
      (Trim(Edit4.Text) = '')
     ) then
     MessageDlg('Um ou mais campos não foram preenchidos.', mtInformation, [mbOk], 0)
  else
  begin
    if CheckBox1.Checked then
    begin
      TStringGridHack(StringGrid1).InsertRow(1);
      Inserir(1, Edit1.Text, Edit2.Text, Edit3.Text, Edit4.Text);
    end
    else
    begin
      { Loop para saber qual a linha que está vazia }
      for I := 0 to StringGrid1.RowCount-1 do
      begin
        if StringGrid1.Cells[0, I] = '' then
        begin
          Inserir(StringGrid1.RowCount-1, Edit1.Text, Edit2.Text, Edit3.Text, Edit4.Text);
          Break;
        end
        else
        begin
          TStringGridHack(StringGrid1).InsertRow(StringGrid1.RowCount);
          Inserir(StringGrid1.RowCount-1, Edit1.Text, Edit2.Text, Edit3.Text, Edit4.Text);
          Break;
        end;
      end;
    end;
    Edit1.Text := '';
    Edit2.Text := '';
    Edit3.Text := '';
    Edit4.Text := '';
  end;
end;

procedure TfrmCADEXE.Button2Click(Sender: TObject);
begin
   frmCADEXE.Close;
  frmprincipal.Show;
end;

procedure TfrmCADEXE.Button3Click(Sender: TObject);
begin
  TStringGridHack(StringGrid1).DeleteRow(1);
end;


end.

